#!/usr/bin/perl
use CGI qw/:standard/;
`rm -Rf /tmp/*_tmp_dir`;

#-- CONFIG
$web_path="/pava_web";                            #-- EXTERNAL REFERENCE (I.E. HTML PATH)
$web_space_path="/var/www/html/pava_web";         #-- INTERNAL REFERENCE (I.E. LINUX FILE SYSTEM PATH)
#-- EDIT THE ABOVE PATHS TO POINT TO THE WEB SPACE (AS REFERENCED EXTERNALLY OR INTERNALLY)

$organs         =param("organs");
@organs =split(" ",$organs);
$play_time      =param("play_time");
$fps            =param("fps");
$paste_data     =param("paste_data");
$time_start     =param("time_start");
$time_step      =param("time_step");
$time_unit      =param("time_unit");
$maxdose        =param("maxdose");
$middose        =param("middose");
$mindose        =param("mindose");
$organism       =param("organism");
$gender         =substr(param("gender"),0,1);

@organ_stack_order=(
"human",
"intestines",
"brain",
"adipose",
"esophagus",
"pancreas",
"thymus",
"bone",
"thyroid",
"muscle",
"bone.marrow",
"skin",
"gonads",
"bladder",
"prostate",
"kidney",
"adrenal",
"lung",
"blood",
"heart",
"spleen",
"stomach",
"mammary",
"liver"
);


@data_rows      =split(/[\r\n]+/, $paste_data); #-- ANY # OF LINE TERMINATORS
for ($i=0;$i<scalar(@data_rows);$i++){
  @cols=split(/\s+/,$data_rows[$i]);
  if (scalar(@cols) == 0){last;}
  if (not defined $time_points){$time_points=scalar(@cols);}
  @{$data[$i]}=@cols;
}
$time_pt=$time_start;
for ($i=0;$i<$time_points;$i++){
  push @timepoints, $time_pt;
  $time_pt+=$time_step;
}

#-- NOW PREPARE DATA FOR OTHER SCRIPT
$min=$timepoints[0];
$max=$timepoints[-1];
$vstep=($max-$min)/($play_time * $fps);  #-- THE VIRTUAL TIME INTERVAL
for ($i=$min;$i<$max;$i+=$vstep){ #-- UP TO BUT NOT EQUAL TO THE LAST DATA TIME POINT
  #-- warn "min $min max $max i $i\n";
  push @vtimepoints, $i;
}
push @vtimepoints,$timepoints[-1]; #-- ADDS LAST TIME POINT IN DATA TO VDATA

for ($i=0;$i<scalar(@vtimepoints);$i++){
  $vtp=$vtimepoints[$i];
  for ($ub=1;$ub<scalar(@timepoints);$ub++){ #-- FIND UPPER BOUNDARY
    if ($timepoints[$ub]>=$vtp){last;}
  }
  #-- warn "$i vtp: $vtp ub: $ub\n";
  $percent_of_interval=($vtp-$timepoints[$ub-1])/($timepoints[$ub]-$timepoints[$ub-1]);
  for ($j=0;$j<scalar(@data);$j++){ #-- NOW POPULATE VIRTUAL DATA
    $vdata[$j][$i]=$percent_of_interval*($data[$j][$ub]-$data[$j][$ub-1])+$data[$j][$ub-1];
  }
}

$tmp_dir=int(rand(1000000))."_tmp_dir";
`mkdir /tmp/$tmp_dir`;

for ($i=0;$i<scalar(@vdata);$i++){            #-- FOR EACH ORGAN
  $organ=$organs[$i];
  if ($organ=~m/(gonads|skin|muscle|adipose)/i){$organ=$1."_$gender";}
  if (not defined $frame_count){$frame_count=scalar(@{$vdata[$i]});}
  for ($j=0;$j<scalar(@{$vdata[$i]});$j++){   #-- FOR EACH DOSE
    $num=substr("000".$j,-4,4);
    $dirname="/tmp/$tmp_dir/frame_".substr("000".$j,-4,4);
    if (not -d $dirname){`mkdir $dirname`;}
    if ($vdata[$i][$j] >=$middose){
      $color=255-int(255*(($vdata[$i][$j]-$middose)/($maxdose-$middose)));
      `/usr/bin/convert -fill "rgb(255,$color,$color)"  -opaque "rgb(255,255,255)" $web_space_path/organs/templates/$organ.png $dirname/$organ.png`;
    }
    else{
      $color=255-int(255*(($middose-$vdata[$i][$j])/($middose-$mindose)));
      `/usr/bin/convert -fill "rgb($color,$color,255)"  -opaque "rgb(255,255,255)" $web_space_path/organs/templates/$organ.png $dirname/$organ.png`;
    }
  }
}

#-- NEED TO WORK OUT STACK ORDER
foreach $stack_organ (@organ_stack_order){ #-- SORT THE RIGHT WAY
  foreach $organ (@organs){                #-- CONSIDER THE ORGANS WE HAVE 
    if ($organ =~m/$stack_organ/i){        #-- ADD WHEN THEY AGREE
      push @new_organ_order, $organ;
    }
  }
} 

`mkdir /tmp/$tmp_dir/animation`;
for ($j=0;$j<$frame_count;$j++){
  $frame_fmt=substr("000".$j,-4,4);
  $out="/tmp/$tmp_dir/animation/frame_$frame_fmt.png";
  `cp $web_space_path/organs/templates/human_$gender.png $out`;
  foreach $organ (@new_organ_order){                #-- CONSIDER THE ORGANS WE HAVE 
    if ($organ=~m/(gonads|skin|muscle|adipose)/i){$organ=$1."_$gender";}
    `composite /tmp/$tmp_dir/frame_$frame_fmt/$organ.png $out $out`;
  }
  $label=sprintf("Time: %6.2f $time_unit", $time_start+($vstep*$j));
  `convert -font /usr/share/fonts/liberation/LiberationMono-Regular.ttf $out -background Khaki label:'$label' -gravity Center -append $out`;
}
$x=100/$fps;
#-- warn "time_step $x"; #-- DEBUG

#-- ANIMATE THE DIR: /tmp/$tmp_dir/animation/
`convert -delay $x -loop 0 /tmp/$tmp_dir/animation/*.png $web_space_path/results/animation.gif`;

#-- `chmod 666 /var/www/html/pava/results/animation.gif`;  #-- WHY NOT WORKING?

#-- CLEAN UP FILES

`rm -Rf /tmp/$tmp_dir`;

print "Content-type: text/html\n\n";   #-- PRINT INIT STRING
print "\n\n";
print qq|
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN" "http://www.w3.org/TR/html4/frameset.dtd">
<html>
<head><title>Animation</title>
<body bgcolor="#009193">
<img src="$web_path/results/animation.gif>
</body>
</html>
|;
