#!/usr/bin/perl
use CGI qw/:standard/;

#-- CONFIG
$cgi_path="/cgi-bin/pava_cgi";  #-- EXTERNAL REFERENCE (I.E. HTML PATH, NOT FILE SYSTEM PATH) 
$web_path="/pava_web";          #-- EXTERNAL REFERENCE (I.E. HTML PATH, NOT FILE SYSTEM PATH)
#-- EDIT THE ABOVE PATHS TO POINT TO THE CGI AND WEB SPACES

$time_start     =param("time_start");
$time_step      =param("time_step");
$time_unit      =param("time_unit");
$paste_data     =param("paste_data");
$organism       =param("org");
  $organism=~s/(_.)$//;
  $gender=$1;
  if ($gender eq "_f"){$gender="female";}
  else {$gender="male";}

$organs_sel     =param("organs_sel");
@organ_names=split(",",$organs_sel);
for($i=0;$i<scalar(@organ_names);$i++){
  $organs[$i]=lc($organ_names[$i]);
  $organs[$i]=~s/ /_/g; 
  $organ_hash{$organs[$i]}=$i;
}

@data_rows      =split(/[\r\n]+/, $paste_data); #-- ANY # OF LINE TERMINATORS
for ($i=0;$i<scalar(@data_rows);$i++){
  @cols=split(/\s+/,$data_rows[$i]);
  if (scalar(@cols) == 0){last;}
  if (not defined $time_points){$time_points=scalar(@cols);}
  @{$data[$i]}=@cols;
}
$time_pt=$time_start;
for ($i=0;$i<$time_points;$i++){
  push @timepoints, $time_pt;
  $time_pt+=$time_step;
}

$maxdose=-10**99;
$mindose=10**99;
#-- ESTABLISH MAXIMUM, MID, MINIMUM DOSE
for ($i=0;$i<scalar(@data);$i++){
  for ($j=0;$j<scalar(@{$data[$i]});$j++){
    if ($maxdose < $data[$i][$j]){$maxdose = $data[$i][$j];}
    if ($mindose > $data[$i][$j]){$mindose = $data[$i][$j];}
  }
}
$middose=0;
if ($mindose>0){
  $middose=0;
  $mindose=0;
}
if ($maxdose<0){
  $middose=0;
  $maxdose=0;
}

print "Content-type: text/html;\n\n";
print "<html><head><title>PAVA - Matrix Representation</title></head><body bgcolor='009193'>\n";
print "<script type='text/javascript' src='$web_path/show.js'> </script>\n";

print "Gender: $gender<br>";

#--------
print "<form name='animate' action='$cgi_path/animate.cgi' method='post' target='animation'>";
print "<div style='position:absolute;top:0px;left:250px;'>";
print "<table border=1>";
print "<tr><td colspan=2 style='text-align:center;'>Color Ranges</td></tr>";
print "<tr><td style='background-color:#f00;'>Max dose</td><td style='text-align:right;'><input onchange='update_colors(\"max\");' type=text size=6 name='maxdose' value='$maxdose'></td></tr>\n";
print "<tr><td style='background-color:#fff;'>Mid dose</td><td style='text-align:right;'><input onchange='update_colors(\"mid\");' type=text size=6 name='middose' value='0'></td></tr>\n";
print "<tr><td style='background-color:#00f;color:#fff;'>Min dose</td><td style='text-align:right;'><input onchange='update_colors(\"min\");' type=text size=6 name='mindose' value='$mindose'></td></tr>\n";
print "</table></div>";

print "<div style='position:absolute;top:150px;left:250px;'><table id='organ_doses' border=1><tr><td></td><td colspan=$time_points style='text-align:center;'>Time points in $time_unit</td></tr>\n";
print "<tr><td/>";
foreach $point (@timepoints){
  printf "<td>%6.2f</td>", $point;
};
print "</tr>\n";
for ($i=0;$i<scalar(@data);$i++){
  if ($organs[$i] eq "gonads"){
    print "<tr><td style='height:65px;width:65px;background:white url($web_path/organs/thumbs/gonads_".substr($gender,0,1).".png) no-repeat;'>$organs[$i]</td>";
  }
  else {
    print "<tr><td style='height:65px;width:65px;background:white url($web_path/organs/thumbs/$organs[$i].png) no-repeat;'>$organs[$i]</td>";
  } 
  for ($j=0;$j<scalar(@{$data[$i]});$j++){
    $val=$data[$i][$j];
    if($val>=0){
      $x=255-(int(255*$val/$maxdose));
      print "<td style='background-color:rgb(255,$x,$x);width:40px;'>$val</td>";
    }
    else {
      $x=255-(int(255*($val/$mindose)));
      print "<td style='background-color:rgb($x,$x,255);width:40px;'>$val</td>";
    }
    # $dose=sprintf("%6.4f",$val);
  }
  print "</tr>\n";
}
print "</table>\n";
$organs_id=join(" ",@organs);
print qq|
<div style="position:absolute;padding-left:5px;top:370px;left:-240px;width:220px;height:110px;border:1px solid black;vertical-align:middle;">

<center>Select Animation Parameters</center>
Playback time (s): <input onchange="document.animate.total_points.value=this.value * document.animate.fps.value;" name="play_time" value=10 size=3/><br>
Frames per second: <input onchange="document.animate.total_points.value=this.value * document.animate.play_time.value;"  name="fps" value=12 size=3/><br>
Result: <input  disabled style="text-align:center;border:none;color:black;background-color:#009193;" type="text" size=3 name="total_points" value=120 /> virtual data points
<input type="hidden" name="organs" value="$organs_id">
<input type="hidden" name="time_start" value="$time_start">
<input type="hidden" name="time_step" value="$time_step">
<input type="hidden" name="time_unit" value="$time_unit">
<input type="hidden" name="paste_data" value="$paste_data">
<input type="hidden" name="organism" value="$organism">
<input type="hidden" name="gender" value="$gender">
<center><button style="background-color:#e8e;" type="submit">Animate!</button></center>
</div>

<!-- 
<div style="position:absolute;top:-300px;left:300px;top:100px;height:400px;width:300px;"><iframe style="width:100%;height:100%;" name="animation" id="animation"></iframe></div>
-->
|;
print "</div>\n";
#--------
print "<br>";
print qq|
<style>
  .organ{
    position:absolute;
    top:100px;
  }
</style>
|;

@organs_stacked=
("human",
"intestines",
"brain",
"adipose",
"esophagus",
"pancreas",
"thymus",
"bone",
"thyroid",
"muscle",
"bone_marrow",
"skin",
"gonads",
"bladder",
"prostate",
"kidney",
"adrenal",
"lung",
"blood",
"heart",
"spleen",
"stomach",
"mammary",
"liver");

$gender_letter=substr($gender,0,1);
if ($gender_letter eq "f"){
  print "<img class='organ' id='body' src='$web_path/organs/standard/human_f.png'>";
}
else {
  print "<img class='organ' id='body' src='$web_path/organs/standard/human_m.png'>";
}
foreach $org (@organs_stacked){
  if (exists($organ_hash{$org})){
    if ($org =~m/(gonads|adipose|muscle|skin|prostate)/i){
      $organ=$1;
      print "<img class='organ' id='gonads' src='$web_path/organs/standard/$organ\_$gender_letter.png';>\n";
    }
    else{
      print "<img class='organ' id='$org' src='$web_path/organs/standard/$org.png';>\n";
    }
  }
}

print "</body></html>";

